import{s as We,n as Re,o as Ye}from"../chunks/scheduler.d6170356.js";import{S as Ge,i as Oe,g as n,s as o,r as u,A as Fe,h as s,f as i,c as l,j as je,u as d,x as r,k as ve,y as Ke,a,v as f,d as c,t as h,w as g}from"../chunks/index.fcd4cc08.js";import{H as y,E as Qe}from"../chunks/EditOnGithub.da2b595c.js";function Ve(xe){let m,F,G,K,$,Q,b,we='<a href="https://github.com/marimo-team/marimo" rel="nofollow">marimo</a> is a reactive notebook for Python that models notebooks as dataflow graphs. When you run a cell or interact with a UI element, marimo automatically runs affected cells (or marks them as stale), keeping code and outputs consistent and preventing bugs before they happen. Every marimo notebook is stored as pure Python, executable as a script, and deployable as an app.',V,v,Te="Key features:",B,x,ke="<li>⚡️ <strong>reactive:</strong> run a cell, and marimo reactively runs all dependent cells or marks them as stale</li> <li>🖐️ <strong>interactive:</strong> bind sliders, tables, plots, and more to Python — no callbacks required</li> <li>🔬 <strong>reproducible:</strong> no hidden state, deterministic execution, built-in package management</li> <li>🏃 <strong>executable:</strong> execute as a Python script, parametrized by CLI args</li> <li>🛜 <strong>shareable:</strong> deploy as an interactive web app or slides, run in the browser via WASM</li> <li>🛢️ <strong>designed for data:</strong> query dataframes and databases with SQL, filter and search dataframes</li>",J,w,N,T,Ce="To get started with marimo on Spaces, click the button below:",X,p,_e='<img src="https://huggingface.co/datasets/huggingface/badges/resolve/main/deploy-to-spaces-lg.svg" alt=""/>',Z,k,Le='This will start building your Space using marimo’s Docker template. If successful, you should see a similar application to the <a href="https://huggingface.co/spaces/marimo-team/marimo-app-template" rel="nofollow">marimo introduction notebook</a>.',ee,C,te,_,Me="When you create a marimo Space, you’ll get a few key files to help you get started:",ie,L,ae,M,He='This is your main marimo notebook file that defines your app’s logic. marimo notebooks are pure Python files that use the <code>@app.cell</code> decorator to define cells. To learn more about building notebooks and apps, see <a href="https://docs.marimo.io" rel="nofollow">the marimo documentation</a>. As your app grows, you can organize your code into modules and import them into your main notebook.',oe,H,le,P,Pe="The Dockerfile for a marimo app is minimal since marimo has few system dependencies. The key requirements are:",ne,S,Se="<li>It installs the dependencies listed in <code>requirements.txt</code> (using <code>uv</code>)</li> <li>It creates a non-root user for security</li> <li>It runs the app using <code>marimo run app.py</code></li>",se,q,qe="You may need to modify this file if your application requires additional system dependencies, permissions, or other CLI flags.",re,z,me,D,ze="The Space will automatically install dependencies listed in the <code>requirements.txt</code> file. At minimum, you must include <code>marimo</code> in this file. You will want to add any other required packages your app needs.",pe,A,De="The marimo Space template provides a basic setup that you can extend based on your needs. When deployed, your notebook will run in “app mode” which hides the code cells and only shows the interactive outputs - perfect for sharing with end users. You can opt to include the code cells in your app by setting adding <code>--include-code</code> to the <code>marimo run</code> command in the Dockerfile.",ue,I,de,E,Ae='<li><a href="https://docs.marimo.io" rel="nofollow">marimo documentation</a></li> <li><a href="https://github.com/marimo-team/marimo" rel="nofollow">marimo GitHub repository</a></li> <li><a href="https://marimo.io/discord" rel="nofollow">marimo Discord</a></li> <li><a href="https://huggingface.co/spaces/marimo-team/marimo-app-template" rel="nofollow">marimo template Space</a></li>',fe,U,ce,j,Ie="If you encounter issues:",he,W,Ee="<li>Make sure your notebook runs locally in app mode using <code>marimo run app.py</code></li> <li>Check that all required packages are listed in <code>requirements.txt</code></li> <li>Verify the port configuration matches (7860 is the default for Spaces)</li> <li>Check Space logs for any Python errors</li>",ge,R,Ue='For more help, visit the <a href="https://marimo.io/discord" rel="nofollow">marimo Discord</a> or <a href="https://github.com/marimo-team/marimo/issues" rel="nofollow">open an issue</a>.',ye,Y,$e,O,be;return $=new y({props:{title:"marimo on Spaces",local:"marimo-on-spaces",headingTag:"h1"}}),w=new y({props:{title:"Deploying marimo apps on Spaces",local:"deploying-marimo-apps-on-spaces",headingTag:"h2"}}),C=new y({props:{title:"Customizing your marimo app",local:"customizing-your-marimo-app",headingTag:"h2"}}),L=new y({props:{title:"1. app.py",local:"1-apppy",headingTag:"h3"}}),H=new y({props:{title:"2. Dockerfile",local:"2-dockerfile",headingTag:"h3"}}),z=new y({props:{title:"3. requirements.txt",local:"3-requirementstxt",headingTag:"h3"}}),I=new y({props:{title:"Additional Resources and Support",local:"additional-resources-and-support",headingTag:"h2"}}),U=new y({props:{title:"Troubleshooting",local:"troubleshooting",headingTag:"h2"}}),Y=new Qe({props:{source:"https://github.com/huggingface/hub-docs/blob/main/docs/hub/spaces-sdks-docker-marimo.md"}}),{c(){m=n("meta"),F=o(),G=n("p"),K=o(),u($.$$.fragment),Q=o(),b=n("p"),b.innerHTML=we,V=o(),v=n("p"),v.textContent=Te,B=o(),x=n("ul"),x.innerHTML=ke,J=o(),u(w.$$.fragment),N=o(),T=n("p"),T.textContent=Ce,X=o(),p=n("a"),p.innerHTML=_e,Z=o(),k=n("p"),k.innerHTML=Le,ee=o(),u(C.$$.fragment),te=o(),_=n("p"),_.textContent=Me,ie=o(),u(L.$$.fragment),ae=o(),M=n("p"),M.innerHTML=He,oe=o(),u(H.$$.fragment),le=o(),P=n("p"),P.textContent=Pe,ne=o(),S=n("ul"),S.innerHTML=Se,se=o(),q=n("p"),q.textContent=qe,re=o(),u(z.$$.fragment),me=o(),D=n("p"),D.innerHTML=ze,pe=o(),A=n("p"),A.innerHTML=De,ue=o(),u(I.$$.fragment),de=o(),E=n("ul"),E.innerHTML=Ae,fe=o(),u(U.$$.fragment),ce=o(),j=n("p"),j.textContent=Ie,he=o(),W=n("ol"),W.innerHTML=Ee,ge=o(),R=n("p"),R.innerHTML=Ue,ye=o(),u(Y.$$.fragment),$e=o(),O=n("p"),this.h()},l(e){const t=Fe("svelte-u9bgzb",document.head);m=s(t,"META",{name:!0,content:!0}),t.forEach(i),F=l(e),G=s(e,"P",{}),je(G).forEach(i),K=l(e),d($.$$.fragment,e),Q=l(e),b=s(e,"P",{"data-svelte-h":!0}),r(b)!=="svelte-8sdgkm"&&(b.innerHTML=we),V=l(e),v=s(e,"P",{"data-svelte-h":!0}),r(v)!=="svelte-1ooaz34"&&(v.textContent=Te),B=l(e),x=s(e,"UL",{"data-svelte-h":!0}),r(x)!=="svelte-op6yfg"&&(x.innerHTML=ke),J=l(e),d(w.$$.fragment,e),N=l(e),T=s(e,"P",{"data-svelte-h":!0}),r(T)!=="svelte-g22yl7"&&(T.textContent=Ce),X=l(e),p=s(e,"A",{href:!0,target:!0,"data-svelte-h":!0}),r(p)!=="svelte-12z7cjx"&&(p.innerHTML=_e),Z=l(e),k=s(e,"P",{"data-svelte-h":!0}),r(k)!=="svelte-102ywad"&&(k.innerHTML=Le),ee=l(e),d(C.$$.fragment,e),te=l(e),_=s(e,"P",{"data-svelte-h":!0}),r(_)!=="svelte-go0u54"&&(_.textContent=Me),ie=l(e),d(L.$$.fragment,e),ae=l(e),M=s(e,"P",{"data-svelte-h":!0}),r(M)!=="svelte-fjfar7"&&(M.innerHTML=He),oe=l(e),d(H.$$.fragment,e),le=l(e),P=s(e,"P",{"data-svelte-h":!0}),r(P)!=="svelte-480mcf"&&(P.textContent=Pe),ne=l(e),S=s(e,"UL",{"data-svelte-h":!0}),r(S)!=="svelte-1codevz"&&(S.innerHTML=Se),se=l(e),q=s(e,"P",{"data-svelte-h":!0}),r(q)!=="svelte-1azw1gq"&&(q.textContent=qe),re=l(e),d(z.$$.fragment,e),me=l(e),D=s(e,"P",{"data-svelte-h":!0}),r(D)!=="svelte-sb2hc"&&(D.innerHTML=ze),pe=l(e),A=s(e,"P",{"data-svelte-h":!0}),r(A)!=="svelte-hw2v7i"&&(A.innerHTML=De),ue=l(e),d(I.$$.fragment,e),de=l(e),E=s(e,"UL",{"data-svelte-h":!0}),r(E)!=="svelte-1lt8adm"&&(E.innerHTML=Ae),fe=l(e),d(U.$$.fragment,e),ce=l(e),j=s(e,"P",{"data-svelte-h":!0}),r(j)!=="svelte-5qd2nl"&&(j.textContent=Ie),he=l(e),W=s(e,"OL",{"data-svelte-h":!0}),r(W)!=="svelte-jmerlz"&&(W.innerHTML=Ee),ge=l(e),R=s(e,"P",{"data-svelte-h":!0}),r(R)!=="svelte-nbkx44"&&(R.innerHTML=Ue),ye=l(e),d(Y.$$.fragment,e),$e=l(e),O=s(e,"P",{}),je(O).forEach(i),this.h()},h(){ve(m,"name","hf:doc:metadata"),ve(m,"content",Be),ve(p,"href","http://huggingface.co/new-space?template=marimo-team/marimo-app-template"),ve(p,"target","_blank")},m(e,t){Ke(document.head,m),a(e,F,t),a(e,G,t),a(e,K,t),f($,e,t),a(e,Q,t),a(e,b,t),a(e,V,t),a(e,v,t),a(e,B,t),a(e,x,t),a(e,J,t),f(w,e,t),a(e,N,t),a(e,T,t),a(e,X,t),a(e,p,t),a(e,Z,t),a(e,k,t),a(e,ee,t),f(C,e,t),a(e,te,t),a(e,_,t),a(e,ie,t),f(L,e,t),a(e,ae,t),a(e,M,t),a(e,oe,t),f(H,e,t),a(e,le,t),a(e,P,t),a(e,ne,t),a(e,S,t),a(e,se,t),a(e,q,t),a(e,re,t),f(z,e,t),a(e,me,t),a(e,D,t),a(e,pe,t),a(e,A,t),a(e,ue,t),f(I,e,t),a(e,de,t),a(e,E,t),a(e,fe,t),f(U,e,t),a(e,ce,t),a(e,j,t),a(e,he,t),a(e,W,t),a(e,ge,t),a(e,R,t),a(e,ye,t),f(Y,e,t),a(e,$e,t),a(e,O,t),be=!0},p:Re,i(e){be||(c($.$$.fragment,e),c(w.$$.fragment,e),c(C.$$.fragment,e),c(L.$$.fragment,e),c(H.$$.fragment,e),c(z.$$.fragment,e),c(I.$$.fragment,e),c(U.$$.fragment,e),c(Y.$$.fragment,e),be=!0)},o(e){h($.$$.fragment,e),h(w.$$.fragment,e),h(C.$$.fragment,e),h(L.$$.fragment,e),h(H.$$.fragment,e),h(z.$$.fragment,e),h(I.$$.fragment,e),h(U.$$.fragment,e),h(Y.$$.fragment,e),be=!1},d(e){e&&(i(F),i(G),i(K),i(Q),i(b),i(V),i(v),i(B),i(x),i(J),i(N),i(T),i(X),i(p),i(Z),i(k),i(ee),i(te),i(_),i(ie),i(ae),i(M),i(oe),i(le),i(P),i(ne),i(S),i(se),i(q),i(re),i(me),i(D),i(pe),i(A),i(ue),i(de),i(E),i(fe),i(ce),i(j),i(he),i(W),i(ge),i(R),i(ye),i($e),i(O)),i(m),g($,e),g(w,e),g(C,e),g(L,e),g(H,e),g(z,e),g(I,e),g(U,e),g(Y,e)}}}const Be='{"title":"marimo on Spaces","local":"marimo-on-spaces","sections":[{"title":"Deploying marimo apps on Spaces","local":"deploying-marimo-apps-on-spaces","sections":[],"depth":2},{"title":"Customizing your marimo app","local":"customizing-your-marimo-app","sections":[{"title":"1. app.py","local":"1-apppy","sections":[],"depth":3},{"title":"2. Dockerfile","local":"2-dockerfile","sections":[],"depth":3},{"title":"3. requirements.txt","local":"3-requirementstxt","sections":[],"depth":3}],"depth":2},{"title":"Additional Resources and Support","local":"additional-resources-and-support","sections":[],"depth":2},{"title":"Troubleshooting","local":"troubleshooting","sections":[],"depth":2}],"depth":1}';function Je(xe){return Ye(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class et extends Ge{constructor(m){super(),Oe(this,m,Je,Ve,We,{})}}export{et as component};
